package strathclyde.cs.relational;
import java.io.*;

/*
*
* Lexanal
*
Part of Mbase
Author Paul Cockshott
Copyright University of Strathclyde

  A lexican analyser class to be used in the parser
*/
public class Lexanal 

{	
	public String theString,lastString;
	private int token,c,state;
	public double theNumber;
	private InputStream inp;
	static int unknown=0;
	static boolean debug=false;
	final	static int var=1;	// parsing a variable
	final	static int str=2;	// parsing a string
	final	static int num=3;	// parsing an integer
	final	static int com=4;	// parsing a comment
	final	static int frac=5;	// parsing a fraction
	final	static int exp=6;	// parsing an exp sign
	final	static int expdig=7; // parsing an exponent
	final   static int eol=8;
	
	
	public final static int TT_QUOTE = '\'';
	public final static int TT_EOL= '\n';
	public final static int TT_EOF= -1;
	public final static int TT_WORD=-2;
	public final static int TT_NUMBER=-3;
	public final static int TT_COMMENT = ';' ;
	public final static int TT_STRING=TT_QUOTE;
	int thebase;
	public Lexanal(InputStream I)throws IOException
	{ 
		inp=(I);
		start();
		
	}
	public Lexanal()throws IOException
		
	{ inp = System.in; start();}
	
	private void start()throws IOException{
		thebase=10;
		state= unknown;
		c=inp.read();
		theString="";
		theNumber=0;
		token=0;
		nextsymbol();
		
	}
	public void nextsymbol() throws IOException
	{	
		
		double power=1.0/thebase;
		int exponent=0;
		boolean negexp=false;
		lastString=theString;
		boolean stop=false;
		if (state==eol) c=inp.read();
		state=unknown;
		while (!stop)
		{	
			if(debug)System.out.print((char)c);
			if(state==unknown){
				if(c==TT_EOF){ stop=true;token=TT_EOF;}
				else
					if(c==TT_EOL){ stop=true;token=TT_EOL;state=eol;}
				else
					if(Character.isLetter((char)c)){ 
					state=var; 
					
					theString=""+(char)c;
				}
				else
					if(Character.isDigit((char)c)){
					state=num; 
					theNumber=Character.digit((char)c,thebase);
				}
				else
					if(c==TT_QUOTE){state= str;theString="";}
				else
					if(c==TT_COMMENT){state=com;}
				else 
					if(c==' '){}	// skip blanks
				else if(c==13){}	// skip crs
				else { stop=true; token = c;c=inp.read();}
			}
			else if(state==var){
				if(Character.isLetterOrDigit((char)c)){
					char k= (char ) c;theString=theString+k;
				}
				else { token=TT_WORD; stop=true;}
				
			}
			else if(state==num){
				if(Character.isDigit((char)c)){
					theNumber=thebase *theNumber+Character.digit((char)c,thebase);
				}
				else if(c=='.'){state=frac;}
				else {stop=true;token=TT_NUMBER;}
				
			}
			else if(state==str){ 				
				if(c==TT_EOF){ stop=true;token=TT_STRING;}
				else
					if(c==TT_QUOTE){stop=true;token=TT_STRING;c=inp.read();}
				else{theString=theString+(char)c;}
			}
			else if(state==com){  
				if(c==TT_EOF){ stop=true;token=TT_EOF;}
				if(c==TT_EOL){ stop=true;token=TT_EOL;}
				
			}
			else if (state==frac){
				if(Character.isDigit((char)c)){
					theNumber=theNumber+power*Character.digit((char)c,thebase);
					power=power/thebase;
				}
				else if(Character.toLowerCase((char)c)=='e'){
					state=exp;exponent=0;
				}
				else {stop=true;token=TT_NUMBER;}
				
			}
			else if (state==exp){
				if(Character.isDigit((char)c)){
					exponent=thebase *exponent+Character.digit((char)c,thebase);
				}
				else
					if(c=='-'){negexp=true;}
				else{stop=true; token=TT_NUMBER;}
				state=expdig;
			}	
			else if (state==expdig){
				if(Character.isDigit((char)c)){
					exponent=thebase *exponent+Character.digit((char)c,thebase);
				}
				
				else{	// multiply number by base^exponent
					stop=true; token=TT_NUMBER;
					while(exponent!=0)
					{ 
						if(exponent>0){ 
							exponent--; 
							theNumber=theNumber*thebase;
						}	  
						else{
							exponent++;
							theNumber=theNumber/thebase;
						}
					}
					state=expdig;
				}
			}
			if (!stop) c=inp.read(); 
		}
		if(debug){
		if(token>32)System.out.println("nextsymbol -> "+(char)token);
		else System.out.println("nextsymbol -> "+token);
		}
	}
	public String toString()
	{ 
		String s=" "+(char)token+" "+token+" "+theString+" "+theNumber;
		return s;
	}
	public boolean have(int symbol)// checks for symbol in input and reads next
	{ 
		try {
			if(token==symbol){
					if(debug)System.out.print("have("+symbol+")");
				nextsymbol();
					if(debug)System.out.print("next("+theString+")");

				return true;
			}
			return false;
		}
		catch (IOException e){ return false; }
	}
	public boolean peek(int symbol)// checks for symbol in input
	{ 
		if(token==symbol){
			return true;
		}
		return false;
		
	}
	public void mustbe(int symbol)// if not symbol give error
		throws KSyntaxError
	{
		if (!have(symbol)) throw new KSyntaxError();
	}
	public boolean have(String symbol)// checks for symbol in input
	{ 
		try{if(token==TT_WORD&&(0==symbol.compareTo(theString))){
			nextsymbol();
			if(debug)System.out.print("have("+theString+")");
			return true;
		}
		return false;
		}
		catch (IOException e){return false; }
	}
	public void mustbe(String symbol)// if not symbol give error
		throws KSyntaxError
	{
		if (!have(symbol)) 
			throw new KSyntaxError(theString+" found where "+symbol+" expected");
	}
	
}
