package strathclyde.cs.relational;
import java.io.*;
import java.util.*;
import strathclyde.cs.relational.operators.*;
import strathclyde.cs.relational.structured.*;
import strathclyde.cs.relational.atomic.*;

/**Part of MdBase implemented in Java
 * Author Nikolaos Kotsis
 * Started August 1997
 * Copyright (c) University of Strathclyde
*/

public class LoadFile 
{
public static void main(String[] argv) throws IOException {
		Text T=new Text("/users/nikos/input3.txt");
		Text T1=new Text("/users/nikos/input3.txt");
		LoadRelation lr=new LoadRelation();
		
		Relation Q = (Relation)lr.apply(T);
		System.out.println(lr.apply(T));

		Relation Q1 = (Relation)lr.apply(T1);//second relation from different input value
		System.out.println(lr.apply(T1));
		
		Enumeration e = Q.members();
		while(e.hasMoreElements()){
			Tuple t = (Tuple)e.nextElement();		
			System.out.println(t);
		//	System.out.println(t+"The number of fields are:"+t.arity());
		System.out.println();
				
		}
		// This is the Projection operation 		
		
		Numeric[] arnumbers = {new Numeric(1),new Numeric(2)};
		Tuple protuple = new Tuple(arnumbers);
		System.out.println("This is the Projection operation");
		System.out.println();
		System.out.println(Q.project(protuple));
		System.out.println();
		
		//This is the Selection operator-eq	

		Moperator Field = new Curried(new Subscript(),new Numeric(1));
		Moperator isz = new Curried(Doperator.EQ,new Text("uk"));
		Moperator Field02 = new Mcomposed(isz,Field);			
		System.out.println("This is the Selection operation with Equal operation");
		System.out.println();
		System.out.println(Q.select(Field02));
		
		//This is the Selection operator-lt
	
		Moperator Field1 = new Curried(new Subscript(),new Numeric(1));
		Moperator isz1 = new Curried(Doperator.LT,new Text("zz"));
		Moperator Field01 = new Mcomposed(isz1,Field1);			
		System.out.println("This is the Selection operation with Lessthan operation");
		System.out.println();
		System.out.println(Q.select(Field01));
		
		//This is the Join operation
	
		
		Numeric[] arnum= {new Numeric(0),new Numeric(1)};
		Tuple jtuple = new Tuple(arnum);
		Moperator sub01 = new Curried(new Subscript(),jtuple);
		Doperator compose1 = new Dcomposed(sub01,new Concat());
		Doperator equi=new Dcomposed(Field1,Doperator.EQ,Field);
		Doperator equijoin=new Join(compose1,equi);
		System.out.println("Join operator");
		System.out.println(equijoin.apply(Q1,Q));
	
		
	}

}

