/**Part of MdBase implemented in Java
 * Author Nikolaos Kotsis
 * Started Aug 1997
 * Copyright (c) University of strathclyde
*/

package strathclyde.cs.relational.atomic;
import strathclyde.cs.relational.*;
// Atomic is the base type of value for holding strings and floating point numbers
	

	
	public class Atomic implements Universal {
		double value;

	public Atomic(double v){
		value=v;
	}
	public  Universal concat (Universal b){
	if(b instanceof Atomic){
			 return new Atomic(value + ((Atomic)b).value);
			 } else{
			return undefinedValue;
		}
	}
	public Universal plus (Universal b){
		 if(b instanceof Atomic){
			 return new Atomic(value + ((Atomic)b).value);
			 } else{
			return undefinedValue;
		}
	}

	public Universal minus (Universal b){
		if(b instanceof Atomic){
			return new Atomic(value - ((Atomic)b).value);
		} else {
			return undefinedValue;
		}
	}
		public Universal times (Universal b){
		if(b instanceof Atomic){
			return new Atomic(value * ((Atomic)b).value);
		} else {
			return undefinedValue;
		}
	}
		public  Universal divide (Universal b){
		if(b instanceof Atomic){
			return new Atomic(value / ((Atomic)b).value);
		} else {
			return undefinedValue;
		}
	}
		public Universal divmod (Universal b){
		if(b instanceof Atomic){
			return new Atomic(value % ((Atomic)b).value);
		} else {
			return undefinedValue;
		}
	}
	
	    public  boolean equals (Universal b){
		if(b instanceof Atomic){
			return (value == ((Atomic)b).value);
		} else {
			return false;
		}
	}
		public  boolean lessthan (Universal b){
		if(b instanceof Atomic){
			return (value <((Atomic)b).value);
		} else {
			return false;
		}
	}

		public  Universal max (Universal b){
		if (lessthan(b)){
			return b;
		} else {
			 return this;}
    }
	  public  Universal min (Universal b){
		if (lessthan(b)){
			return this;
		} else {
			  return b;}
    }
	    public String toString (){
			
		//	System.out.print(value + "" );
		    return value + "" ;	
		}
}
